<?php

declare(strict_types=1);

namespace Dedi\SyliusCustomerPricingPlugin\Loader\ProductVariant;

use Dedi\SyliusCustomerPricingPlugin\Entity\ChannelPricing\ChannelPricingSubjectInterface;
use Dedi\SyliusCustomerPricingPlugin\Loader\ChannelPricingLoaderInterface;
use Dedi\SyliusCustomerPricingPlugin\Repository\ChannelPricingRepositoryInterface;
use Doctrine\Common\Collections\Collection;
use Sylius\Component\Core\Model\ProductVariantInterface;

class DefaultChannelPricingLoader implements ChannelPricingLoaderInterface
{
    public function __construct(
        private ChannelPricingRepositoryInterface $channelPricingRepository,
    ) {
    }

    public function load(ChannelPricingSubjectInterface $object): Collection
    {
        return $this->channelPricingRepository->findDefaultForProductVariant($object);
    }

    public function supports(ChannelPricingSubjectInterface $object): bool
    {
        return $object instanceof ProductVariantInterface;
    }
}
