<?php

declare(strict_types=1);

namespace Dedi\SyliusCustomerPricingPlugin\Processor\Order;

use Dedi\SyliusCustomerPricingPlugin\Entity\Customer\OrganizationAwareInterface;
use Sylius\Component\Core\Model\OrderInterface as BaseOrderInterface;
use Sylius\Component\Order\Model\OrderInterface;
use Sylius\Component\Order\Processor\OrderProcessorInterface;

class OrganizationOrderProcessor implements OrderProcessorInterface
{
    public function process(OrderInterface $order): void
    {
        if (!$order instanceof OrganizationAwareInterface ||
            !$order instanceof BaseOrderInterface
        ) {
            return;
        }

        $customer = $order->getCustomer();

        if (null === $customer || !$customer instanceof OrganizationAwareInterface) {
            return;
        }

        $order->setOrganization($customer->getOrganization());
    }
}
