<?php

declare(strict_types=1);

namespace Dedi\SyliusCustomerPricingPlugin\Repository;

use Dedi\SyliusCustomerPricingPlugin\Entity\Customer\OrganizationInterface;
use Doctrine\Common\Collections\Collection;
use Sylius\Component\Core\Model\CustomerInterface;
use Sylius\Component\Core\Model\ProductVariantInterface;
use Sylius\Component\Customer\Model\CustomerGroupInterface;
use Sylius\Component\Resource\Repository\RepositoryInterface;

interface ChannelPricingRepositoryInterface extends RepositoryInterface
{
    public function findForProductVariant(ProductVariantInterface $productVariant, string $type): Collection;

    public function findDefaultForProductVariant(ProductVariantInterface $productVariant): Collection;

    public function findForCustomerForProductVariant(ProductVariantInterface $productVariant, CustomerInterface $customer): Collection;

    public function findForOrganizationForProductVariant(ProductVariantInterface $productVariant, OrganizationInterface $organization): Collection;

    public function findForCustomerGroupForProductVariant(ProductVariantInterface $productVariant, CustomerGroupInterface $customerGroup): Collection;
}
