<?php

declare(strict_types=1);

namespace Dedi\SyliusCustomerPricingPlugin\Repository\Trait;

use Dedi\SyliusCustomerPricingPlugin\Entity\ChannelPricing\Customer\CustomerChannelPricing;
use Dedi\SyliusCustomerPricingPlugin\Entity\ChannelPricing\CustomerGroup\CustomerGroupChannelPricing;
use Dedi\SyliusCustomerPricingPlugin\Entity\ChannelPricing\Organization\OrganizationChannelPricing;
use Doctrine\ORM\QueryBuilder;
use Sylius\Component\Core\Model\Channel;

trait ChannelPricingRepositoryTrait
{
    abstract public function createListQueryBuilder(string $alias = 'o'): QueryBuilder;

    public function createCustomerPricingListQueryBuilder(string $alias = 'o')
    {
        $queryBuilder = $this->createListQueryBuilder($alias);
        $queryBuilder
            ->leftJoin(Channel::class, 'channel', 'WITH', 'o.channelCode = channel.code')

            ->leftJoin(CustomerChannelPricing::class, 'ccp', 'WITH', 'o.id = ccp.id')
            ->leftJoin('ccp.customer', 'customer', 'WITH', 'ccp.customer = customer.id')

            ->leftJoin(OrganizationChannelPricing::class, 'ocp', 'WITH', 'o.id = ocp.id')
            ->leftJoin('ocp.organization', 'organization', 'WITH', 'ocp.organization = organization.id')

            ->leftJoin(CustomerGroupChannelPricing::class, 'cgcp', 'WITH', 'o.id = cgcp.id')
            ->leftJoin('cgcp.customerGroup', 'customerGroup', 'WITH', 'cgcp.customerGroup = customerGroup.id')
        ;

        return $queryBuilder;
    }
}
