<?php

declare(strict_types=1);

namespace Dedi\SyliusCustomerPricingPlugin\Repository\Trait;

use Doctrine\ORM\QueryBuilder;

trait OrganizationAwareRepositoryTrait
{
    abstract public function createListQueryBuilder(): QueryBuilder;

    public function createByOrganizationIdQueryBuilder($organizationId): QueryBuilder
    {
        return $this->createListQueryBuilder()
            ->andWhere('o.organization = :organization')
            ->setParameter('organization', $organizationId);
    }
}
